
/* ////////////////////////////////////
   
   Affichage des codes DTMF reçus.
   Utilise un décodeur MT8870
   Afficheur LCD 2 lignes 16 caractères
   Version 1.0
   F5MNA janvier 2014  http://f5mna.free.fr
  
   /////////////////////////////////////
*/

//Port Serie
#include <SoftwareSerial.h> 
SoftwareSerial mySerial(1, 2); // RX, TX

//LCD
#include <LiquidCrystal.h>
// LCD RS pin to digital pin 8
// LCD Enable pin to digital pin 9
// LCD D4 pin to digital pin 4
// LCD D5 pin to digital pin 5
// LCD D6 pin to digital pin 6
// LCD D7 pin to digital pin 7
// LCD R/W pin to ground
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

//

int ConfDTMF = 3;  // Confirmation de réception d'un code DTMF Pin 3
int DTMF1 = 10;    // Sortie 1 MT8870 Pin 11
int DTMF2 = 11;    // Sortie 2 MT8870     12
int DTMF3 = 12;    // Sortie 3 MT8870     13
int DTMF4 = 13;    // Sortie 4 MT8870     14
int DTMF = 0;      // Sommes sorties DTMF
int BTRAZ = 2;     // Efface ligne de codes
int Curs = -1;     // Position du curseur
String Code;       //  codes

int val; // confirmation DTMF (ConfDTMF)
int valBt; // Bouton RAZ
int buttonState; // Prise en compte du changement d'état de la confirmation DTMF


void setup()  
 {

  pinMode (ConfDTMF,INPUT); // Validation code DTMF
  pinMode (DTMF1,INPUT); // Sortie MT8870
  pinMode (DTMF2,INPUT); // Sortie MT8870
  pinMode (DTMF3,INPUT); // Sortie MT8870
  pinMode (DTMF4,INPUT); // Sortie MT8870
  
  pinMode(BTRAZ,INPUT); // Boutin RAZ ligne codes
  
  buttonState = digitalRead(ConfDTMF);
  
  ///
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
  lcd.print ("   codes DTMF   ");
  lcd.setCursor(0, 1);
  lcd.print ("F5MNA  Version 1");
  delay(3000);
  lcd.setCursor(0, 0);
  lcd.print ("   Codes DTMF   ");
  lcd.setCursor(0, 1);
  lcd.print ("                ");
 }

void loop ()
  {
    
 valBt = digitalRead(BTRAZ);
 if (valBt == HIGH) {
 lcd.setCursor(0, 1);
 lcd.print ("                 ");    
 Curs = 0; }
 
 val = digitalRead(ConfDTMF); //Confirmation DTMF
 if (val != buttonState) { // Modification de cette valeur
 if (val == LOW) { // Si la valeur à changé.
 Curs++; // Incrementation du compteur curseur (seconde ligne)
 
 if (Curs > 15){
 lcd.setCursor(0, 1);
 lcd.print ("                 ");    
 Curs = 0; 
 }
  
 //DTMF = 0;
   if (digitalRead(DTMF4) == HIGH) DTMF = DTMF + 1;
   if (digitalRead(DTMF3) == HIGH) DTMF = DTMF + 2;
   if (digitalRead(DTMF2) == HIGH) DTMF = DTMF + 4;
   if (digitalRead(DTMF1) == HIGH) DTMF = DTMF + 8;
   
 
   switch (DTMF)
   {
     case 0:
     Code = "D";
     break; 
     case 1:
     Code = "1";
     break; 
     case 2:
     Code = "2";
     break; 
     case 3:
     Code = "3";
     break; 
     case 4:
     Code = "4";
     break; 
     case 5:
     Code = "5";
     break; 
     case 6:
     Code = "6";
     break; 
     case 7:
     Code = "7";
     break;      
     case 8:
     Code = "8";
     break;  
      case 9:
     Code = "9";
     break;     
     case 10:
     Code = "0";
     break; 
     case 11:
     Code = "*";
     break;      
     case 12:
     Code = "#";
     break;
     case 13:
     Code = "A";
     break; 
     case 14:
     Code = "B";
     break; 
     case 15:
     Code = "C";
     break;       
   }    
   lcd.setCursor(Curs, 1);
   lcd.print (Code);
       }
     } 
     buttonState = val; // Confirmation de la validation DTMF (CM8870)
     DTMF = 0;
 }


 

